<!DOCTYPE html>
<!-- Generated by pkgdown: do not edit by hand --><html lang="en">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<title>Quickcheck inspired property based testing in R  • quickcheck</title>
<!-- jquery --><script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.4.1/jquery.min.js" integrity="sha256-CSXorXvZcTkaix6Yvo6HppcZGetbYMGWSFlBw8HfCJo=" crossorigin="anonymous"></script><!-- Bootstrap --><link href="https://cdnjs.cloudflare.com/ajax/libs/bootswatch/3.4.0/flatly/bootstrap.min.css" rel="stylesheet" crossorigin="anonymous">
<script src="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/3.4.1/js/bootstrap.min.js" integrity="sha256-nuL8/2cJ5NDSSwnKD8VqreErSWHtnEP9E7AySL+1ev4=" crossorigin="anonymous"></script><!-- bootstrap-toc --><link rel="stylesheet" href="bootstrap-toc.css">
<script src="bootstrap-toc.js"></script><!-- Font Awesome icons --><link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.12.1/css/all.min.css" integrity="sha256-mmgLkCYLUQbXn0B1SRqzHar6dCnv9oZFPEC1g1cwlkk=" crossorigin="anonymous">
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.12.1/css/v4-shims.min.css" integrity="sha256-wZjR52fzng1pJHwx4aV2AO3yyTOXrcDW7jBpJtTwVxw=" crossorigin="anonymous">
<!-- clipboard.js --><script src="https://cdnjs.cloudflare.com/ajax/libs/clipboard.js/2.0.6/clipboard.min.js" integrity="sha256-inc5kl9MA1hkeYUt+EC3BhlIgyp/2jDIyBLS6k3UxPI=" crossorigin="anonymous"></script><!-- headroom.js --><script src="https://cdnjs.cloudflare.com/ajax/libs/headroom/0.11.0/headroom.min.js" integrity="sha256-AsUX4SJE1+yuDu5+mAVzJbuYNPHj/WroHuZ8Ir/CkE0=" crossorigin="anonymous"></script><script src="https://cdnjs.cloudflare.com/ajax/libs/headroom/0.11.0/jQuery.headroom.min.js" integrity="sha256-ZX/yNShbjqsohH1k95liqY9Gd8uOiE1S4vZc+9KQ1K4=" crossorigin="anonymous"></script><!-- pkgdown --><link href="pkgdown.css" rel="stylesheet">
<script src="pkgdown.js"></script><link href="extra.css" rel="stylesheet">
<meta property="og:title" content="Quickcheck inspired property based testing in R ">
<meta property="og:description" content="Quickcheck inspired property based testing in R. 
  Provides a custom expectation to be used with testthat for
  property based testing, as well as composable data generators.">
<!-- mathjax --><script src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.5/MathJax.js" integrity="sha256-nvJJv9wWKEm88qvoQl9ekL2J+k/RWIsaSScxxlsrv8k=" crossorigin="anonymous"></script><script src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.5/config/TeX-AMS-MML_HTMLorMML.js" integrity="sha256-84DKXVJXs0/F8OTMzX4UR909+jtl4G7SPypPavF+GfA=" crossorigin="anonymous"></script><!--[if lt IE 9]>
<script src="https://oss.maxcdn.com/html5shiv/3.7.3/html5shiv.min.js"></script>
<script src="https://oss.maxcdn.com/respond/1.4.2/respond.min.js"></script>
<![endif]-->
</head>
<body data-spy="scroll" data-target="#toc">
    <div class="container template-home">
      <header><div class="navbar navbar-default navbar-fixed-top" role="navigation">
  <div class="container">
    <div class="navbar-header">
      <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#navbar" aria-expanded="false">
        <span class="sr-only">Toggle navigation</span>
        <span class="icon-bar"></span>
        <span class="icon-bar"></span>
        <span class="icon-bar"></span>
      </button>
      <span class="navbar-brand">
        <a class="navbar-link" href="index.html">quickcheck</a>
        <span class="version label label-default" data-toggle="tooltip" data-placement="bottom" title="Released version">0.0.0.9000</span>
      </span>
    </div>

    <div id="navbar" class="navbar-collapse collapse">
      <ul class="nav navbar-nav">
<li>
  <a href="index.html">
    <span class="fas fa-home fa-lg"></span>
     
  </a>
</li>
<li>
  <a href="reference/index.html">Reference</a>
</li>
<li class="dropdown">
  <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-expanded="false">
    Articles
     
    <span class="caret"></span>
  </a>
  <ul class="dropdown-menu" role="menu">
<li>
      <a href="articles/generator-outputs.html">Example generator outputs</a>
    </li>
  </ul>
</li>
      </ul>
<ul class="nav navbar-nav navbar-right"></ul>
</div>
<!--/.nav-collapse -->
  </div>
<!--/.container -->
</div>
<!--/.navbar -->

      

      </header><div class="row">
  <div class="contents col-md-9">


<!-- badges: end -->
<div id="overview" class="section level1">
<div class="page-header"><h1 class="hasAnchor">
<a href="#overview" class="anchor"></a>Overview</h1></div>
<p>Property based testing in R, inspired by <a href="https://en.wikipedia.org/wiki/QuickCheck">Quickcheck</a>. This package builds on the property based testing framework provided by <a href="https://github.com/hedgehogqa/r-hedgehog"><code>hedgehog</code></a> and is designed to seamlessly integrate with a <a href="https://testthat.r-lib.org"><code>testthat</code></a>.</p>
<div id="installation" class="section level2">
<h2 class="hasAnchor">
<a href="#installation" class="anchor"></a>Installation</h2>
<p>You can install the development version of quickcheck from <a href="https://github.com/">GitHub</a> with:</p>
<div class="sourceCode" id="cb1"><pre class="downlit sourceCode r">
<code class="sourceCode R"><span class="co"># install.packages("remotes")</span>
<span class="fu">remotes</span><span class="fu">::</span><span class="fu"><a href="https://remotes.r-lib.org/reference/install_github.html">install_github</a></span><span class="op">(</span><span class="st">"quickcheckr/quickcheck"</span><span class="op">)</span></code></pre></div>
</div>
</div>
<div id="usage" class="section level1">
<h1 class="hasAnchor">
<a href="#usage" class="anchor"></a>Usage</h1>
<p>The following example uses quickcheck to test the properties of the base R <code><a href="https://rdrr.io/r/base/Arithmetic.html">+</a></code> function. <a href="https://fsharpforfunandprofit.com/posts/property-based-testing/">Here</a> is an introduction to the concept of property based testing, and an explanation of the mathematical properties of addition can be found <a href="https://www.khanacademy.org/math/cc-sixth-grade-math/cc-6th-factors-and-multiples/properties-of-numbers/a/properties-of-addition">here</a>.</p>
<div id="commutative-property-of-addition" class="section level3">
<h3 class="hasAnchor">
<a href="#commutative-property-of-addition" class="anchor"></a>Commutative property of addition</h3>
<div class="sourceCode" id="cb2"><pre class="downlit sourceCode r">
<code class="sourceCode R"><span class="kw"><a href="https://rdrr.io/r/base/library.html">library</a></span><span class="op">(</span><span class="va"><a href="https://testthat.r-lib.org">testthat</a></span><span class="op">)</span>
<span class="kw"><a href="https://rdrr.io/r/base/library.html">library</a></span><span class="op">(</span><span class="va">quickcheck</span><span class="op">)</span>

<span class="fu"><a href="https://testthat.r-lib.org/reference/test_that.html">test_that</a></span><span class="op">(</span><span class="st">"+ is commutative"</span>, <span class="op">{</span>
  
  <span class="fu">quickcheck</span><span class="op">(</span>
    
    property <span class="op">=</span> 
      <span class="op">(</span>\<span class="op">(</span><span class="va">x</span>, <span class="va">y</span><span class="op">)</span> <span class="va">x</span> <span class="op">+</span> <span class="va">y</span><span class="op">)</span> <span class="op">%=&gt;%</span> 
      <span class="va">expect_equal</span> <span class="op">%=&gt;%</span> 
      <span class="op">(</span>\<span class="op">(</span><span class="va">x</span>, <span class="va">y</span><span class="op">)</span> <span class="va">y</span> <span class="op">+</span> <span class="va">x</span><span class="op">)</span>,
    
    for_all <span class="op">=</span> <span class="fu"><a href="reference/arbitrary.html">arbitrary</a></span><span class="op">(</span>
      .. <span class="op">=</span> <span class="fu">..equal_length</span><span class="op">(</span>
        x <span class="op">=</span> <span class="fu"><a href="reference/..numeric.html">..numeric</a></span><span class="op">(</span><span class="op">)</span>,
        y <span class="op">=</span> <span class="fu"><a href="reference/..numeric.html">..numeric</a></span><span class="op">(</span><span class="op">)</span>
      <span class="op">)</span>
    <span class="op">)</span>
    
  <span class="op">)</span>
  
<span class="op">}</span><span class="op">)</span>
<span class="co">#&gt; Test passed 😀</span></code></pre></div>
</div>
<div id="associative-property-of-addition" class="section level3">
<h3 class="hasAnchor">
<a href="#associative-property-of-addition" class="anchor"></a>Associative property of addition</h3>
<div class="sourceCode" id="cb3"><pre class="downlit sourceCode r">
<code class="sourceCode R"><span class="fu"><a href="https://testthat.r-lib.org/reference/test_that.html">test_that</a></span><span class="op">(</span><span class="st">"+ is associative"</span>, <span class="op">{</span>
  
  <span class="fu">quickcheck</span><span class="op">(</span>
    
    property <span class="op">=</span> 
      <span class="op">(</span>\<span class="op">(</span><span class="va">x</span>, <span class="va">y</span>, <span class="va">z</span><span class="op">)</span> <span class="va">x</span> <span class="op">+</span> <span class="op">(</span><span class="va">y</span> <span class="op">+</span> <span class="va">z</span><span class="op">)</span><span class="op">)</span> <span class="op">%=&gt;%</span>
      <span class="va">expect_equal</span> <span class="op">%=&gt;%</span>
      <span class="op">(</span>\<span class="op">(</span><span class="va">x</span>, <span class="va">y</span>, <span class="va">z</span><span class="op">)</span> <span class="op">(</span><span class="va">x</span> <span class="op">+</span> <span class="va">y</span><span class="op">)</span> <span class="op">+</span> <span class="va">z</span><span class="op">)</span>,
    
    for_all <span class="op">=</span> <span class="fu"><a href="reference/arbitrary.html">arbitrary</a></span><span class="op">(</span>
      .. <span class="op">=</span> <span class="fu">..equal_length</span><span class="op">(</span>
        x <span class="op">=</span> <span class="fu"><a href="reference/..numeric.html">..numeric</a></span><span class="op">(</span><span class="op">)</span>,
        y <span class="op">=</span> <span class="fu"><a href="reference/..numeric.html">..numeric</a></span><span class="op">(</span><span class="op">)</span>,
        z <span class="op">=</span> <span class="fu"><a href="reference/..numeric.html">..numeric</a></span><span class="op">(</span><span class="op">)</span>
      <span class="op">)</span>
    <span class="op">)</span>
    
  <span class="op">)</span>
  
<span class="op">}</span><span class="op">)</span>
<span class="co">#&gt; Test passed 🎊</span></code></pre></div>
</div>
<div id="identity-property-of-addition" class="section level3">
<h3 class="hasAnchor">
<a href="#identity-property-of-addition" class="anchor"></a>Identity property of addition</h3>
<div class="sourceCode" id="cb4"><pre class="downlit sourceCode r">
<code class="sourceCode R"><span class="fu"><a href="https://testthat.r-lib.org/reference/test_that.html">test_that</a></span><span class="op">(</span><span class="st">"0 is the additive identity of +"</span>, <span class="op">{</span>
  
  <span class="fu">quickcheck</span><span class="op">(</span>
    
    property <span class="op">=</span> 
      <span class="op">(</span>\<span class="op">(</span><span class="va">x</span><span class="op">)</span> <span class="va">x</span> <span class="op">+</span> <span class="fl">0</span><span class="op">)</span> <span class="op">%=&gt;%</span> 
      <span class="va">expect_equal</span> <span class="op">%=&gt;%</span> 
      <span class="op">(</span>\<span class="op">(</span><span class="va">x</span><span class="op">)</span> <span class="va">x</span><span class="op">)</span>,
    
    for_all <span class="op">=</span> <span class="fu"><a href="reference/arbitrary.html">arbitrary</a></span><span class="op">(</span>
      x <span class="op">=</span> <span class="fu"><a href="reference/..numeric.html">..numeric</a></span><span class="op">(</span><span class="op">)</span>
    <span class="op">)</span>
    
  <span class="op">)</span>
  
<span class="op">}</span><span class="op">)</span>
<span class="co">#&gt; Test passed 🥇</span></code></pre></div>
</div>
</div>
<div id="type-safety" class="section level1">
<h1 class="hasAnchor">
<a href="#type-safety" class="anchor"></a>Type safety</h1>
<p>quickcheck also introduces an opinionated way to validate type-safety. R is a weakly typed, dynamic language so errors can only be caught at runtime. In this context a type-safe function can be considered any function that behaves properly with valid inputs and throws an error with invalid inputs.</p>
<p>For example, a type-safe addition function may only accept integer or double vectors of equal length and it should throw if there are any NA values, NaNs, infinites, or if the vector has attributes. This function can be defined in base R like this.</p>
<div class="sourceCode" id="cb5"><pre class="downlit sourceCode r">
<code class="sourceCode R"><span class="va">safe_add</span> <span class="op">&lt;-</span> <span class="kw">function</span><span class="op">(</span><span class="va">x</span>, <span class="va">y</span><span class="op">)</span> <span class="op">{</span>
  <span class="fu"><a href="https://rdrr.io/r/base/stopifnot.html">stopifnot</a></span><span class="op">(</span>
    <span class="fu"><a href="https://rdrr.io/r/base/numeric.html">is.numeric</a></span><span class="op">(</span><span class="va">x</span><span class="op">)</span>,
    <span class="fu"><a href="https://rdrr.io/r/base/numeric.html">is.numeric</a></span><span class="op">(</span><span class="va">y</span><span class="op">)</span>,
    <span class="op">!</span><span class="fu"><a href="https://rdrr.io/r/base/NA.html">is.na</a></span><span class="op">(</span><span class="va">x</span><span class="op">)</span>, 
    <span class="op">!</span><span class="fu"><a href="https://rdrr.io/r/base/NA.html">is.na</a></span><span class="op">(</span><span class="va">y</span><span class="op">)</span>,
    <span class="op">!</span><span class="fu"><a href="https://rdrr.io/r/base/is.finite.html">is.nan</a></span><span class="op">(</span><span class="va">x</span><span class="op">)</span>, 
    <span class="op">!</span><span class="fu"><a href="https://rdrr.io/r/base/is.finite.html">is.nan</a></span><span class="op">(</span><span class="va">y</span><span class="op">)</span>,
    <span class="op">!</span><span class="fu"><a href="https://rdrr.io/r/base/is.finite.html">is.infinite</a></span><span class="op">(</span><span class="va">x</span><span class="op">)</span>,
    <span class="op">!</span><span class="fu"><a href="https://rdrr.io/r/base/is.finite.html">is.infinite</a></span><span class="op">(</span><span class="va">y</span><span class="op">)</span>,
    <span class="fu"><a href="https://rdrr.io/r/base/NULL.html">is.null</a></span><span class="op">(</span><span class="fu"><a href="https://rdrr.io/r/base/attributes.html">attributes</a></span><span class="op">(</span><span class="va">x</span><span class="op">)</span><span class="op">)</span>,
    <span class="fu"><a href="https://rdrr.io/r/base/NULL.html">is.null</a></span><span class="op">(</span><span class="fu"><a href="https://rdrr.io/r/base/attributes.html">attributes</a></span><span class="op">(</span><span class="va">y</span><span class="op">)</span><span class="op">)</span>,
    <span class="fu"><a href="https://rdrr.io/r/base/length.html">length</a></span><span class="op">(</span><span class="va">x</span><span class="op">)</span> <span class="op">==</span> <span class="fu"><a href="https://rdrr.io/r/base/length.html">length</a></span><span class="op">(</span><span class="va">y</span><span class="op">)</span>,
    <span class="fu"><a href="https://rdrr.io/r/base/length.html">length</a></span><span class="op">(</span><span class="va">x</span><span class="op">)</span> <span class="op">&gt;=</span> <span class="fl">1</span>, 
    <span class="fu"><a href="https://rdrr.io/r/base/length.html">length</a></span><span class="op">(</span><span class="va">y</span><span class="op">)</span> <span class="op">&gt;=</span> <span class="fl">1</span>
  <span class="op">)</span>
  
  <span class="va">x</span> <span class="op">+</span> <span class="va">y</span>
<span class="op">}</span></code></pre></div>
<p>Testing for type-safety is as easy as adding the argument <code>type_safe = TRUE</code>. This will cause quickcheck to automatically generate malformed inputs and test if the function throws an error when it should.</p>
<div class="sourceCode" id="cb6"><pre class="downlit sourceCode r">
<code class="sourceCode R"><span class="fu"><a href="https://testthat.r-lib.org/reference/test_that.html">test_that</a></span><span class="op">(</span><span class="st">"add is commutative and type-safe"</span>, <span class="op">{</span>
  
  <span class="fu">quickcheck</span><span class="op">(</span>
    type_safe <span class="op">=</span> <span class="cn">TRUE</span>,
    
    property <span class="op">=</span> 
      <span class="op">(</span>\<span class="op">(</span><span class="va">x</span>, <span class="va">y</span><span class="op">)</span> <span class="fu">safe_add</span><span class="op">(</span><span class="va">x</span>, <span class="va">y</span><span class="op">)</span><span class="op">)</span> <span class="op">%=&gt;%</span> 
      <span class="va">expect_equal</span> <span class="op">%=&gt;%</span> 
      <span class="op">(</span>\<span class="op">(</span><span class="va">x</span>, <span class="va">y</span><span class="op">)</span> <span class="fu">safe_add</span><span class="op">(</span><span class="va">y</span>, <span class="va">x</span><span class="op">)</span><span class="op">)</span>,
    
    for_all <span class="op">=</span> <span class="fu"><a href="reference/arbitrary.html">arbitrary</a></span><span class="op">(</span>
      .. <span class="op">=</span> <span class="fu">..equal_length</span><span class="op">(</span>
        x <span class="op">=</span> <span class="fu"><a href="reference/..numeric.html">..numeric</a></span><span class="op">(</span><span class="op">)</span>,
        y <span class="op">=</span> <span class="fu"><a href="reference/..numeric.html">..numeric</a></span><span class="op">(</span><span class="op">)</span>
      <span class="op">)</span>
    <span class="op">)</span>
  <span class="op">)</span>
  
<span class="op">}</span><span class="op">)</span>
<span class="co">#&gt; Test passed 🌈</span>

<span class="fu"><a href="https://testthat.r-lib.org/reference/test_that.html">test_that</a></span><span class="op">(</span><span class="st">"+ is associative and type-safe"</span>, <span class="op">{</span>
  
  <span class="fu">quickcheck</span><span class="op">(</span>
    type_safe <span class="op">=</span> <span class="cn">TRUE</span>,
    
    property <span class="op">=</span> 
      <span class="op">(</span>\<span class="op">(</span><span class="va">x</span>, <span class="va">y</span>, <span class="va">z</span><span class="op">)</span> <span class="fu">safe_add</span><span class="op">(</span><span class="va">x</span>, <span class="fu">safe_add</span><span class="op">(</span><span class="va">y</span>, <span class="va">z</span><span class="op">)</span><span class="op">)</span><span class="op">)</span> <span class="op">%=&gt;%</span> 
      <span class="va">expect_equal</span> <span class="op">%=&gt;%</span> 
      <span class="op">(</span>\<span class="op">(</span><span class="va">x</span>, <span class="va">y</span>, <span class="va">z</span><span class="op">)</span> <span class="fu">safe_add</span><span class="op">(</span><span class="fu">safe_add</span><span class="op">(</span><span class="va">x</span>, <span class="va">y</span><span class="op">)</span>, <span class="va">z</span><span class="op">)</span><span class="op">)</span>,
    
    for_all <span class="op">=</span> <span class="fu"><a href="reference/arbitrary.html">arbitrary</a></span><span class="op">(</span>
      .. <span class="op">=</span> <span class="fu">..equal_length</span><span class="op">(</span>
        x <span class="op">=</span> <span class="fu"><a href="reference/..numeric.html">..numeric</a></span><span class="op">(</span><span class="op">)</span>,
        y <span class="op">=</span> <span class="fu"><a href="reference/..numeric.html">..numeric</a></span><span class="op">(</span><span class="op">)</span>,
        z <span class="op">=</span> <span class="fu"><a href="reference/..numeric.html">..numeric</a></span><span class="op">(</span><span class="op">)</span>
      <span class="op">)</span>
    <span class="op">)</span>
  <span class="op">)</span>
  
<span class="op">}</span><span class="op">)</span>
<span class="co">#&gt; Test passed 🎊</span>

<span class="fu"><a href="https://testthat.r-lib.org/reference/test_that.html">test_that</a></span><span class="op">(</span><span class="st">"0 is the additive identity of + and type-safe"</span>, <span class="op">{</span>
  
  <span class="fu">quickcheck</span><span class="op">(</span>
    type_safe <span class="op">=</span> <span class="cn">TRUE</span>,
    
    property <span class="op">=</span> 
      <span class="op">(</span>\<span class="op">(</span><span class="va">x</span>, <span class="va">y</span><span class="op">)</span> <span class="fu">safe_add</span><span class="op">(</span><span class="va">x</span>, <span class="va">y</span><span class="op">)</span><span class="op">)</span> <span class="op">%=&gt;%</span> 
      <span class="va">expect_equal</span> <span class="op">%=&gt;%</span> 
      <span class="op">(</span>\<span class="op">(</span><span class="va">x</span>, <span class="va">y</span><span class="op">)</span> <span class="va">x</span><span class="op">)</span>,
    
    for_all <span class="op">=</span> <span class="fu"><a href="reference/arbitrary.html">arbitrary</a></span><span class="op">(</span>
      .. <span class="op">=</span> <span class="fu">..equal_length</span><span class="op">(</span>
        x <span class="op">=</span> <span class="fu"><a href="reference/..numeric.html">..numeric</a></span><span class="op">(</span><span class="op">)</span>,
        y <span class="op">=</span> <span class="fu"><a href="reference/..numeric_bounded.html">..numeric_bounded</a></span><span class="op">(</span><span class="fl">0</span>, <span class="fl">0</span><span class="op">)</span>
      <span class="op">)</span>
    <span class="op">)</span>
  <span class="op">)</span>
  
<span class="op">}</span><span class="op">)</span>
<span class="co">#&gt; Test passed 🎉</span></code></pre></div>
<p>This method of testing type-safety considers any data that doesn’t match the definition in <code>for_all = arbitrary( ... )</code> as malformed. For example, if the definition is <code><a href="reference/arbitrary.html">arbitrary(x = ..integer())</a></code> then valid data are non-empty integer vectors of any length, containing no NAs and having no attributes. Invalid data are anything that doesn’t fit that definition.</p>
<p>Ideally quickcheck would test for every possible input. In practice, however, to increase efficiency quickcheck only tests the most likely culprits. In the case of integer vectors, likely culprits include double vectors, character vectors, logical vectors, empty integer vectors, integer vectors with attributes, and integer vectors containing NAs. Examples of malformed data generated by quickcheck can be seen with <code>..fail()</code>.</p>
<div class="sourceCode" id="cb7"><pre class="downlit sourceCode r">
<code class="sourceCode R"><span class="fu"><a href="reference/..integer.html">..integer</a></span><span class="op">(</span><span class="op">)</span> |&gt; <span class="fu">..length</span><span class="op">(</span><span class="fl">5</span><span class="op">)</span> |&gt; <span class="fu">..fail</span><span class="op">(</span><span class="op">)</span>
<span class="co">#&gt; Quickcheck generator:</span>
<span class="co">#&gt; Example:</span>
<span class="co">#&gt; [1]  TRUE FALSE FALSE FALSE FALSE</span>
<span class="fu"><a href="reference/..integer.html">..integer</a></span><span class="op">(</span><span class="op">)</span> |&gt; <span class="fu">..length</span><span class="op">(</span><span class="fl">5</span><span class="op">)</span> |&gt; <span class="fu">..fail</span><span class="op">(</span><span class="op">)</span>
<span class="co">#&gt; Quickcheck generator:</span>
<span class="co">#&gt; Example:</span>
<span class="co">#&gt;  a  a    </span>
<span class="co">#&gt;  1  1 NA</span>
<span class="fu"><a href="reference/..integer.html">..integer</a></span><span class="op">(</span><span class="op">)</span> |&gt; <span class="fu">..length</span><span class="op">(</span><span class="fl">5</span><span class="op">)</span> |&gt; <span class="fu">..fail</span><span class="op">(</span><span class="op">)</span>
<span class="co">#&gt; Quickcheck generator:</span>
<span class="co">#&gt; Example:</span>
<span class="co">#&gt; [1]         0 -15165420         0         0 -16180923</span>
<span class="fu"><a href="reference/..integer.html">..integer</a></span><span class="op">(</span><span class="op">)</span> |&gt; <span class="fu">..length</span><span class="op">(</span><span class="fl">5</span><span class="op">)</span> |&gt; <span class="fu">..fail</span><span class="op">(</span><span class="op">)</span>
<span class="co">#&gt; Quickcheck generator:</span>
<span class="co">#&gt; Example:</span>
<span class="co">#&gt; [1] -24277659  68155588         0         0 -22778029</span></code></pre></div>
</div>

  </div>

  <div class="col-md-3 hidden-xs hidden-sm" id="pkgdown-sidebar">
    <div class="license">
<h2>License</h2>
<ul class="list-unstyled">
<li><a href="LICENSE.html">Full license</a></li>
<li><small><a href="https://opensource.org/licenses/mit-license.php">MIT</a> + file <a href="LICENSE-text.html">LICENSE</a></small></li>
</ul>
</div>
<div class="developers">
<h2>Developers</h2>
<ul class="list-unstyled">
<li>Andrew McNeil <br><small class="roles"> Author, maintainer </small> <a href="https://orcid.org/YOUR-ORCID-ID" target="orcid.widget" aria-label="ORCID"><span class="fab fa-orcid orcid" aria-hidden="true"></span></a> </li>
</ul>
</div>

  <div class="dev-status">
<h2>Dev status</h2>
<ul class="list-unstyled">
<li><a href="https://CRAN.R-project.org/package=quickcheck"><img src="https://www.r-pkg.org/badges/version/quickcheck" alt="CRAN status"></a></li>
<li><a href="https://lifecycle.r-lib.org/articles/stages.html#experimental"><img src="https://img.shields.io/badge/lifecycle-experimental-orange.svg" alt="Lifecycle: experimental"></a></li>
</ul>
</div>
</div>
</div>


      <footer><div class="copyright">
  <p>Developed by Andrew McNeil.</p>
</div>

<div class="pkgdown">
  <p>Site built with <a href="https://pkgdown.r-lib.org/">pkgdown</a> 1.6.1.</p>
</div>

      </footer>
</div>

  


  </body>
</html>
